//+------------------------------------------------------------------+
//|                                   ADXcrosses_true_with_sound.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Orange
#property indicator_width1 1
#property indicator_width2 1
//---- input parameters
extern bool Sound = true;
extern int  ADXcrossesPeriod = 14,tip=0;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
double b4plusdi, b4minusdi, nowplusdi, nowminusdi, nShift;
datetime uplast=0;
datetime dnlast=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    SetIndexStyle(0, DRAW_ARROW);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, ExtMapBuffer1);
//----
    SetIndexStyle(1, DRAW_ARROW);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, ExtMapBuffer2);
//---- name for DataWindow and indicator subwindow label
    IndicatorShortName("ADXcrosses(" + ADXcrossesPeriod + ")");
    SetIndexLabel(0, "ADXcrUp");
    SetIndexLabel(1, "ADXcrDn"); 
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();
//---- check for possible errors
    if(counted_bars < 0) 
        return(-1);
//---- last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
//----
    for(int i = 0; i < limit; i++)
      {
      
      
      
        int    MA=14;     
        double Deviation=0.15;     
        int    Mode=MODE_SMA;//0-sma, 1-ema, 2-smma, 3-lwma     
        int    Price=PRICE_CLOSE;//0-close, 1-open, 2-high, 3-low, 4-median, 5-typic, 6-wieight         
        double envH0, envL0, m0;    
        double envH1, envL1, m1;     
 
        envH0=iEnvelopes(NULL, 0, MA, Mode, 0, Price, Deviation, MODE_UPPER, i);      
        envL0=iEnvelopes(NULL, 0, MA, Mode, 0, Price, Deviation, MODE_LOWER, i);      
        envH1=iEnvelopes(NULL, 0, MA, Mode, 0, Price, Deviation, MODE_UPPER, i+1);      
        envL1=iEnvelopes(NULL, 0, MA, Mode, 0, Price, Deviation, MODE_LOWER, i+1);        
        m0 = (Low[i]+High[i])/2;    
        m1 = (Low[i+1]+High[i+1])/2;     
 
       //-----         
       //      
         
        if (envL0>m0 && envL1>m1 && (tip==2 || tip==0)) { ExtMapBuffer1[i] = Low[i] - nShift; tip=1;}           
        if (envH0<m0 && envH1<m1 && (tip==1 || tip==0)) { ExtMapBuffer2[i] = High[i] + nShift;tip=2;}              
           
       //      
                
        if (envH0<m0 && envH1<m1 && tip==1) {ExtMapBuffer2[i] = High[i];}//Closse return (OP_BUY);         
        if (envL0>m0 && envL1>m1 && tip==2) {ExtMapBuffer1[i] = Low[i]; }//Closse return (OP_SELL);   
      
      }
      
//---- Sound
      if(ExtMapBuffer1[0]!=0.0 && Time[i]>uplast && Sound==true) 
        {
          PlaySound("alert.wav");
          uplast=Time[i];
        }
      if(ExtMapBuffer2[0]!=0.0 && Time[i]>dnlast && Sound==true) 
        {
          PlaySound("alert.wav");
          dnlast=Time[i];
        }
//----
    return(0);
  }
//+------------------------------------------------------------------+

